////////////////////////////////////////////////////////////////////////////////
//
//  THIS CODE IS NOT REDISTRIBUTABLE OR APPROVED FOR USE IN/ON ANY OTHER UI 
//  ELEMENT OR PRODUCT COMPONENT.
//  Copyright (c) Microsoft Corporation.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
// Initialize
//
////////////////////////////////////////////////////////////////////////////////
window.onerror=handleErr;
System.Gadget.onSettingsClosing = SettingsClosing;

////////////////////////////////////////////////////////////////////////////////
//
// Setup the gadget
//
////////////////////////////////////////////////////////////////////////////////
function init() 
{
    loadStrings();

    var propShowOrganizer = System.Gadget.Settings.read("showOrganizer");
    var propShowPrivateAppts = System.Gadget.Settings.read("showPrivateAppts");
    var propGadgetSize = System.Gadget.Settings.read("gadgetSize");

    if (propShowOrganizer != "true")
    {
        showOrganizer.checked = false;
    }
    else
    {
        showOrganizer.checked = true;
    }

    if (propShowPrivateAppts != "true")
    {
        showPrivateAppts.checked = false;
    }
    else
    {
        showPrivateAppts.checked = true;	
    }
        
    if (propGadgetSize != "large")
    {
        selectGadgetSize.value = "normal";
    }
    else
    {
        selectGadgetSize.value = "large";
    }
    
    showOrganizerOnChange();
}

////////////////////////////////////////////////////////////////////////////////
//
// Load the UI strings from localized resources
//
////////////////////////////////////////////////////////////////////////////////
function loadStrings()
{
    labelShowOrganizer.innerText = L_SettingsShowOrganizer_Checkbox;
    divOrganizerWarning.innerText = L_SettingsShowOrganizerWarning_Message;
    labelShowPrivateAppts.innerText = L_SettingsShowPrivateAppointments_Checkbox;
    labelGadgetSize.innerText = L_SettingsGadgetSize_ComboBox;
    
    // Add options for gadget size
    var sizeNormal = document.createElement("OPTION");
    selectGadgetSize.options.add(sizeNormal);
    sizeNormal.innerText = L_SettingsGadgetSizeNormal_Text;
    sizeNormal.value = "normal";    
    
    var sizeLarge = document.createElement("OPTION");
    selectGadgetSize.options.add(sizeLarge);
    sizeLarge.innerText = L_SettingsGadgetSizeLarge_Text;
    sizeLarge.value = "large";
}


////////////////////////////////////////////////////////////////////////////////
//
// Save settings on close
//
////////////////////////////////////////////////////////////////////////////////
function SettingsClosing(event)
{
    if (event.closeAction == event.Action.commit) 
    { 
        var propShowOrganizer;
        var propShowPrivateAppts;
        var propGadgetSize;
        
        if (showOrganizer.checked == true)
        {
            propShowOrganizer = "true";
        }
        else
        {
            propShowOrganizer = "false";
        }
      
        if (showPrivateAppts.checked == true)
        {
            propShowPrivateAppts = "true";
        }
        else
        {
            propShowPrivateAppts = "false";
        }
            
        propGadgetSize = selectGadgetSize.value;
      
      System.Gadget.Settings.write("showOrganizer", propShowOrganizer);
      System.Gadget.Settings.write("showPrivateAppts", propShowPrivateAppts);
      System.Gadget.Settings.write("gadgetSize", propGadgetSize);
    }
    
    event.cancel = false;
}

////////////////////////////////////////////////////////////////////////////////
//
// Display organizer warning if checked
//
////////////////////////////////////////////////////////////////////////////////
function showOrganizerOnChange()
{
    System.Debug.outputString("OnChange");
    var obj = showOrganizer;
    if (obj.checked)
    {
        divOrganizerWarning.style.display = "";
    }
    else
    {
        divOrganizerWarning.style.display = "none";
    }

}

////////////////////////////////////////////////////////////////////////////////
//
// Debug: Write error messages to debug logging
//
////////////////////////////////////////////////////////////////////////////////
function handleErr(msg,url,l)
{
    System.Debug.outputString("Problem: " + msg + "\nLine: " + l);
    return true;
}